#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <tlhelp32.h>
#include <commctrl.h>
#include <commdlg.h>
#include <shellapi.h>
#include "resource.h"
#include "PEFile.h"
HINSTANCE hInst;
#define WS_EX_LAYERED 0x00080000 

TCHAR szFileName[256]={0};

int CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM IParam)
{
	RECT Rect; 
	RECT Desktop={0};
	DWORD DlgWidth={0};
	DWORD DlgHeith={0};
	DWORD DlgX={0};
	DWORD DlgY={0};
	UINT_PTR TimeID=0;
	HBITMAP Bitmap={0};
	HDC hdc;
	PAINTSTRUCT Ps={0};
	HDC hMemDC={0};
	long Ret;
    switch(uMsg)
    {
		case WM_INITDIALOG:
			Ret=(GetWindowLong(hWnd,GWL_EXSTYLE)|WS_EX_LAYERED);
			SetWindowLong(hWnd,GWL_EXSTYLE,Ret);
			GetWindowRect(hWnd,&Rect);
			GetWindowRect(GetDesktopWindow(),&Desktop);
			DlgHeith=Rect.bottom-Rect.top;
			DlgWidth=Rect.right-Rect.left;
			DlgY=(Desktop.bottom-DlgHeith)/2;
			DlgX=(Desktop.right-DlgWidth)/2;
			MoveWindow(hWnd,DlgX,DlgY,DlgWidth,DlgHeith,FALSE);
			SetWindowPos(hWnd,HWND_TOP,DlgX,DlgY,DlgWidth,DlgHeith,SWP_SHOWWINDOW);
			Ret=1;
			do{
			    SetLayeredWindowAttributes(hWnd,RGB(0,0,0),Ret,LWA_ALPHA);
				RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
				SendMessage(hWnd,WM_PAINT,0,0);
			    Sleep(3);
				Ret++;
			}while(Ret!=256);
			TimeID=SetTimer(hWnd,1,2000,NULL);
			break;
		case WM_TIMER:
			SendMessage(hWnd,WM_LBUTTONDOWN,0,0);
			KillTimer(hWnd,TimeID);
			break;
		case WM_PAINT:
			hdc=BeginPaint(hWnd,&Ps);
		    Bitmap=LoadBitmap(hInst,(LPCTSTR)IDB_ME);
		    hMemDC=CreateCompatibleDC(NULL);
		    SelectObject(hMemDC,Bitmap);
		    BitBlt(Ps.hdc,DlgX,DlgY,200,60,hMemDC,0,0,SRCCOPY); 
		 // SetRect(&Rect,40,54,60,25);
         // SetTextColor(hdc, RGB(255,0,0)) ; 
		 // SetBkColor(hdc,RGB(255,255,255));
		 // SetBkMode(hdc, TRANSPARENT); //͸ 
     	 // DrawText (hdc, TEXT("BY:Check"), -1,&Rect, DT_CENTER|DT_TOP) ;
			EndPaint(hWnd,&Ps);
			break;
		case WM_LBUTTONDOWN:
			Ret=(GetWindowLong(hWnd,GWL_EXSTYLE)| WS_EX_LAYERED);
			SetWindowLong(hWnd,GWL_EXSTYLE,Ret);
			DeleteDC(hMemDC);
			Ret=255;
			do{
			    SetLayeredWindowAttributes(hWnd,RGB(0,0,0),Ret,LWA_ALPHA);
				RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
			    Sleep(3);
				Ret--;
			}while(Ret!=0);
		    DeleteDC(hMemDC);
			EndDialog(hWnd,0);
			break;
    }
    return DefWindowProc(hWnd,uMsg,wParam,IParam);
}
BOOL CheckPassword(char *Password,int Len)
{
	WORD Word;
	int i=0;
	while(i!=8)
	{
		*(DWORD*)(Password+i)^=0x1234567;
		Password[i]&=0xE;
		i+=4;
    }
	i=0;
	while(i!=8)
	{
		Password[8]+=Password[i];
		i++;
	}
	i=0;
	while(i!=8)
	{
		*(DWORD*)(Password+i)^=0x89ABCDE;
		Password[i]&=0xE;
		i+=4;
    }
	i=0;
	while(i!=8)
	{
		Password[9]+=Password[i];
		i++;
	}
	Word=*(WORD*)(Password+8);
	if(Word!=0xDE42)
	{
		return TRUE;
	}
	Word=*(WORD*)(Password+8);
	Word^=0xEEEE;
	if(Word!=0x30AC)
	{
		return TRUE;
	}
	Word=*(WORD*)(Password);
	Word+=0x3592;
	if(Word!=0xE59A)
	{
		return TRUE;
	}
	if(*(DWORD*)Password!=0x7A81B008)
	{
		return TRUE;
	}
	if(*(DWORD*)(Password+4)!=0x388DBF02)
	{
		return TRUE;
	}
	if(*(BYTE*)(Password+5)!=0xBF||*(BYTE*)(Password+6)!=0x8D)
	{
		return TRUE;
	}
	if(*(BYTE*)(Password+5)!=0xBF)
	{
		return TRUE;
	}
	return FALSE;
}
/*void ButtonProc(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	char Password[MAX_PATH]={0};
	BOOL Result;
    switch(LOWORD(wParam))
    {
        case IDC_CHECK:
			GetDlgItemText(hWnd,IDC_PASSWORD,Password,MAX_PATH);
			if(strlen(Password)>=0xb)
			{
				MessageBox(hWnd,"Password Error!","Check",MB_OK);
				break;
			}
			Result=CheckPassword(Password,strlen(Password));
		    if(Result==TRUE)
			{
				MessageBox(hWnd,"Password Error!","Check",MB_OK);
				break;
			}
			MessageBox(hWnd,"Password Correct!","Check",MB_OK);
            break;           
		case IDC_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT), NULL,WindowProc);
			break;
    }
}*/
LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam) 
{
     PKBDLLHOOKSTRUCT p;
     p = (PKBDLLHOOKSTRUCT) lParam;
	 HWND hWnd=GetActiveWindow();
	 char Password[MAX_PATH]={0};
	 BOOL Result=TRUE;
	 long Ret;
     if (nCode == HC_ACTION) 
	 {
        switch (wParam) 
		{
        case WM_KEYDOWN:    //ϵͳ̰
			if(p->vkCode == VK_RETURN)  //س
			{
				GetDlgItemText(hWnd,IDC_PASSWORD,Password,MAX_PATH);
			    if(strlen(Password)>=0xb)
			    {
				    MessageBox(hWnd,"Password Error!","Check",MB_OK);
				    break;
			    }
			    Result=CheckPassword(Password,strlen(Password));
				break;
			}
			break;
		case WM_SYSKEYDOWN: 
			break;
        case WM_KEYUP:      //ϵͳͷ
			if(p->vkCode == VK_RETURN) //سͷ      
		    {
		        if(Result==TRUE)
			    {
				    MessageBox(hWnd,"Password Error!","Check",MB_OK);
				    break;
			    }
			    MessageBox(hWnd,"Password Correct!","Check",MB_OK);
				break;
			}
			if(p->vkCode == VK_ESCAPE) //Escͷ
			{
			    Ret=(GetWindowLong(hWnd,GWL_EXSTYLE)| WS_EX_LAYERED);
			    SetWindowLong(hWnd,GWL_EXSTYLE,Ret);
			    Ret=255;
			    do{
			         SetLayeredWindowAttributes(hWnd,RGB(0,0,0),Ret,LWA_ALPHA);
				     RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
			         Sleep(3);
				     Ret--;
			    }while(Ret!=0);
				EndDialog(hWnd,0);
				break;
			}
			if(p->vkCode == VK_F1)    //F1ͷ     
			{
				DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT), NULL,WindowProc);
			}
			break;
        case WM_SYSKEYUP:   
            break;
        }
     }
     return  CallNextHookEx(NULL, nCode, wParam,lParam);
  }
BOOL CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HICON  hIcon;
	RECT Rect; 
	RECT Desktop={0};
	DWORD DlgWidth={0};
	DWORD DlgHeith={0};
	DWORD DlgX={0};
	DWORD DlgY={0};
	HBITMAP Bitmap={0};
	HDC hdc;
	PAINTSTRUCT Ps={0};
	HDC hMemDC={0};
	static HBRUSH hbrRed;
	long Ret;
    switch(uMsg)
    {
        case WM_INITDIALOG:
			Ret=(GetWindowLong(hWnd,GWL_EXSTYLE)|WS_EX_LAYERED);
			SetWindowLong(hWnd,GWL_EXSTYLE,Ret);
            hIcon = LoadIcon(hInst,(LPCTSTR)IDI_ICON);
            SendMessage(hWnd,WM_SETICON,TRUE,(WPARAM)hIcon);

	
			GetWindowRect(hWnd,&Rect);
			GetWindowRect(GetDesktopWindow(),&Desktop);
			DlgHeith=(Rect.bottom-Rect.top);
			DlgWidth=(Rect.right-Rect.left);
			DlgY=(Desktop.bottom-DlgHeith)/2;
			DlgX=(Desktop.right-DlgWidth)/2;
			SetWindowPos(hWnd,HWND_TOP,DlgX,DlgY,DlgWidth,DlgHeith,SWP_SHOWWINDOW);
			hbrRed = CreateSolidBrush(RGB(212,208,200));
			Ret=1;
			do{
			    SetLayeredWindowAttributes(hWnd,RGB(0,0,0),Ret,LWA_ALPHA);
				RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
			    Sleep(3);
				Ret++;
			}while(Ret!=256);
		//	SendMessage(hWnd,WM_CREATE,0,0); //λͼť
			SendMessage(hWnd,WM_PAINT,0,0);
			break;
        case WM_CLOSE:
			Ret=(GetWindowLong(hWnd,GWL_EXSTYLE)| WS_EX_LAYERED);
			SetWindowLong(hWnd,GWL_EXSTYLE,Ret);
			DeleteDC(hMemDC);
			Ret=255;
			do{
			    SetLayeredWindowAttributes(hWnd,RGB(0,0,0),Ret,LWA_ALPHA);
				RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
			    Sleep(3);
				Ret--;
			}while(Ret!=0);
            ExitProcess(0);
            break;
        case WM_COMMAND:
			//ButtonProc(hWnd,wParam,lParam); //ťϢ
			break;
		case WM_LBUTTONDOWN:
			Ret=(GetWindowLong(hWnd,GWL_EXSTYLE)| WS_EX_LAYERED);
			SetWindowLong(hWnd,GWL_EXSTYLE,Ret);
			Ret=255;
			do{
			    SetLayeredWindowAttributes(hWnd,RGB(0,0,0),Ret,LWA_ALPHA);
				RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
			    Sleep(3);
				Ret--;
			}while(Ret!=0);
			EndDialog(hWnd,0);
		case WM_PAINT:
			hdc=BeginPaint(hWnd,&Ps);
		    Bitmap=LoadBitmap(hInst,(LPCTSTR)IDB_BITMAP);
		    hMemDC=CreateCompatibleDC(NULL);
		    SelectObject(hMemDC,Bitmap);
		    BitBlt(Ps.hdc,DlgX,DlgY,360,140,hMemDC,0,0,SRCCOPY); 
		    hdc=BeginPaint(GetDlgItem(hWnd,IDC_PASSWORD),&Ps);
            SetTextColor(hdc, RGB(255,0,0)) ; 
		    SetBkColor(hdc,RGB(255,255,255));
		    SetBkMode(hdc, TRANSPARENT); 
			EndPaint(hWnd,&Ps);
			break;
		case WM_CTLCOLOREDIT:
			if (GET_WM_CTLCOLOR_HWND(wParam,lParam,msg) == GetDlgItem(hWnd, IDC_PASSWORD))
			{
                SetTextColor(GET_WM_CTLCOLOR_HDC(wParam,lParam,msg), RGB(255,255,255));
                SetBkColor(GET_WM_CTLCOLOR_HDC(wParam,lParam,msg), RGB(212,208,200));
                return (LRESULT)hbrRed;
			}
			break;  
		/*case WM_CREATE:
            Bitmap=LoadBitmap(hInst,(LPCTSTR)IDB_ABOUT);     //λͼť
            SendMessage(GetDlgItem(hWnd,IDC_ABOUT),BM_SETIMAGE,0,(WPARAM)Bitmap);
            Bitmap=LoadBitmap(hInst,(LPCTSTR)IDB_CHECK);     //λͼť
            SendMessage(GetDlgItem(hWnd,IDC_CHECK),BM_SETIMAGE,0,(WPARAM)Bitmap);
			break;*/
    }
    return FALSE;
}
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
    HHOOK hhkLowLevelKybd  = SetWindowsHookEx(WH_KEYBOARD_LL, LowLevelKeyboardProc, hInstance, 0);
    hInst=hInstance;
    DialogBox(hInstance, MAKEINTRESOURCE(DLG_MAIN), NULL, DialogProc);
	UnhookWindowsHookEx(hhkLowLevelKybd);
	return TRUE;
}
